Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/simu_airs.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/simu_airs.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/simu_airs.F90	(revision 3605)
@@ -2,15 +2,17 @@
         module m_simu_airs
 
+        USE print_control_mod, ONLY: prt_level,lunout
+          
         implicit none
 
-        real, parameter :: tau_thresh = 0.05 ! seuil nuages detectables
-        real, parameter :: p_thresh = 445.   ! seuil nuages hauts
-        real, parameter :: em_min = 0.2      ! seuils nuages semi-transp
-        real, parameter :: em_max = 0.85
-        real, parameter :: undef = 999.
+        REAL, PARAMETER :: tau_thresh = 0.05 ! seuil nuages detectables
+        REAL, PARAMETER :: p_thresh = 445.   ! seuil nuages hauts
+        REAL, PARAMETER :: em_min = 0.2      ! seuils nuages semi-transp
+        REAL, PARAMETER :: em_max = 0.85
+        REAL, PARAMETER :: undef = 999.
 
         contains
 
-        real function search_tropopause(P,T,alt,N) result(P_tropo)
+        REAL function search_tropopause(P,T,alt,N) result(P_tropo)
 ! this function searches for the tropopause pressure in [hPa].
 ! The search is based on ideology described in
@@ -18,11 +20,11 @@
 ! GRL, 30(20) 2042, doi:10.1029/2003GL018240, 2003
 
-        integer N,i,i_lev,first_point,exit_flag,i_dir
-        real P(N),T(N),alt(N),slope(N)
-        real P_min, P_max, slope_limit,slope_2km, &
+        INTEGER N,i,i_lev,first_point,exit_flag,i_dir
+        REAL P(N),T(N),alt(N),slope(N)
+        REAL P_min, P_max, slope_limit,slope_2km, &
      & delta_alt_limit,tmp,delta_alt
-        parameter(P_min=75.0, P_max=470.0)   ! hPa
-        parameter(slope_limit=0.002)         ! 2 K/km converted to K/m
-        parameter(delta_alt_limit=2000.0)    ! 2000 meters
+        PARAMETER(P_min=75.0, P_max=470.0)   ! hPa
+        PARAMETER(slope_limit=0.002)         ! 2 K/km converted to K/m
+        PARAMETER(delta_alt_limit=2000.0)    ! 2000 meters
 
         do i=1,N-1
@@ -93,12 +95,12 @@
 
      
-        integer :: i, n, nss
-
-        integer, intent(in) :: len_cs
-        real, dimension(:), intent(in) :: rneb_cs, temp_cs
-        real, dimension(:), intent(in) :: emis_cs, iwco_cs, rad_cs
-        real, dimension(:), intent(in) :: pres_cs, dz_cs, rhodz_cs
-
-        real, intent(out) :: cc_tot_cs, cc_hc_cs, cc_hist_cs, &
+        INTEGER :: i, n, nss
+
+        INTEGER, intent(in) :: len_cs
+        REAL, DIMENSION(:), intent(in) :: rneb_cs, temp_cs
+        REAL, DIMENSION(:), intent(in) :: emis_cs, iwco_cs, rad_cs
+        REAL, DIMENSION(:), intent(in) :: pres_cs, dz_cs, rhodz_cs
+
+        REAL, intent(out) :: cc_tot_cs, cc_hc_cs, cc_hist_cs, &
      & cc_Cb_cs, cc_ThCi_cs, cc_Anv_cs, &
      & pcld_hc_cs, tcld_hc_cs, em_hc_cs, iwp_hc_cs, &
@@ -109,15 +111,18 @@
      & deltaz_hc_cs, deltaz_hist_cs, rad_hist_cs
 
-        real, dimension(len_cs) :: rneb_ord
-        real :: rneb_min
-
-        real, dimension(:), allocatable :: s, s_hc, s_hist, rneb_max
-        real, dimension(:), allocatable :: sCb, sThCi, sAnv
-        real, dimension(:), allocatable :: iwp_ss, pcld_ss, tcld_ss,&
+        REAL, DIMENSION(len_cs) :: rneb_ord
+        REAL :: rneb_min
+
+        REAL, DIMENSION(:), allocatable :: s, s_hc, s_hist, rneb_max
+        REAL, DIMENSION(:), allocatable :: sCb, sThCi, sAnv
+        REAL, DIMENSION(:), allocatable :: iwp_ss, pcld_ss, tcld_ss,&
      & emis_ss
-        real, dimension(:), allocatable :: deltaz_ss, rad_ss
-
-
-        write(*,*) 'dans cloud_structure'
+        REAL, DIMENSION(:), allocatable :: deltaz_ss, rad_ss
+
+        CHARACTER (len = 50)      :: modname = 'simu_airs.cloud_structure'
+        CHARACTER (len = 160)     :: abort_message
+        
+
+        write(lunout,*) 'dans cloud_structure'
 
         call ordonne(len_cs, rneb_cs, rneb_ord)
@@ -300,13 +305,11 @@
         if (cc_tot_cs .gt. maxval(rneb_cs) .and. &
      & abs(cc_tot_cs-maxval(rneb_cs)) .gt. 1.e-4 )  then
-        write(*,*) 'cc_tot_cs > max rneb_cs'
-        write(*,*) cc_tot_cs, maxval(rneb_cs)
-        STOP
+          WRITE(abort_message,*) 'cc_tot_cs > max rneb_cs', cc_tot_cs, maxval(rneb_cs)
+          CALL abort_physic(modname,abort_message,1)
         endif
 
         if (iwp_hc_cs .lt. 0.) then
-        write(*,*) 'cloud_structure:'
-        write(*,*) 'iwp_hc_cs < 0'
-        STOP
+          abort_message= 'cloud_structure: iwp_hc_cs < 0'
+          CALL abort_physic(modname,abort_message,1)
         endif
  
@@ -316,6 +319,6 @@
         subroutine normal_undef(num, den)
 
-        real, intent(in) :: den
-        real, intent(inout) :: num
+        REAL, intent(in) :: den
+        REAL, intent(inout) :: num
 
         if (den .ne. 0) then
@@ -330,7 +333,7 @@
         subroutine normal2_undef(res,num,den)
 
-        real, intent(in) :: den
-        real, intent(in) :: num
-        real, intent(out) :: res
+        REAL, intent(in) :: den
+        REAL, intent(in) :: num
+        REAL, intent(out) :: res
 
         if (den .ne. 0.) then
@@ -350,18 +353,21 @@
      & emis, pcld, tcld, iwp, deltaz, rad)
 
-        integer, intent(in) :: len_cs
-        real, dimension(len_cs), intent(in) :: rneb_cs, temp_cs
-        real, dimension(len_cs), intent(in) :: emis_cs, iwco_cs, &
+        INTEGER, intent(in) :: len_cs
+        REAL, DIMENSION(len_cs), intent(in) :: rneb_cs, temp_cs
+        REAL, DIMENSION(len_cs), intent(in) :: emis_cs, iwco_cs, &
      & rneb_ord
-        real, dimension(len_cs), intent(in) :: pres_cs, dz_cs, rad_cs
-        real, dimension(len_cs), intent(in) :: rhodz_cs
-        real, dimension(len_cs) :: tau_cs, w
-        real, intent(in) :: rnebmax
-        real, intent(inout) :: stot, shc, shist
-        real, intent(inout) :: sCb, sThCi, sAnv
-        real, intent(out) :: emis, pcld, tcld, iwp, deltaz, rad
-
-        integer :: i, ideb, ibeg, iend, nuage, visible
-        real :: som, som_tau, som_iwc, som_dz, som_rad, tau
+        REAL, DIMENSION(len_cs), intent(in) :: pres_cs, dz_cs, rad_cs
+        REAL, DIMENSION(len_cs), intent(in) :: rhodz_cs
+        REAL, DIMENSION(len_cs) :: tau_cs, w
+        REAL, intent(in) :: rnebmax
+        REAL, intent(inout) :: stot, shc, shist
+        REAL, intent(inout) :: sCb, sThCi, sAnv
+        REAL, intent(out) :: emis, pcld, tcld, iwp, deltaz, rad
+
+        INTEGER :: i, ideb, ibeg, iend, nuage, visible
+        REAL :: som, som_tau, som_iwc, som_dz, som_rad, tau
+
+        CHARACTER (len = 50)      :: modname = 'simu_airs.sous_section'
+        CHARACTER (len = 160)     :: abort_message
 
 
@@ -491,16 +497,16 @@
 
         if (iwp .lt. 0.) then
-        write(*,*) 'ideb iwp =', ideb, iwp
-        STOP
+          WRITE(abort_message,*) 'ideb iwp =', ideb, iwp
+          CALL abort_physic(modname,abort_message,1)
         endif
 
         if (deltaz .lt. 0.) then
-        write(*,*) 'ideb deltaz =', ideb, deltaz
-        STOP
+          WRITE(abort_message,*)'ideb deltaz =', ideb, deltaz
+          CALL abort_physic(modname,abort_message,1)
         endif
 
         if (emis .lt. 0.048 .and. emis .ne. 0.) then
-        write(*,*) 'ideb emis =', ideb, emis
-        STOP
+          WRITE(abort_message,*) 'ideb emis =', ideb, emis
+          CALL abort_physic(modname,abort_message,1)
         endif
 
@@ -511,11 +517,11 @@
      & visible, w)
 
-        integer, intent(in) :: ibeg, iend
-        real, intent(in) :: som_tau
-
-        integer, intent(inout) :: visible
-        real, dimension(:), intent(inout) :: w
-
-        integer :: i
+        INTEGER, intent(in) :: ibeg, iend
+        REAL, intent(in) :: som_tau
+
+        INTEGER, intent(inout) :: visible
+        REAL, DIMENSION(:), intent(inout) :: w
+
+        INTEGER :: i
 
 
@@ -553,12 +559,15 @@
      & som_tau, som_iwc, som_dz, som_rad)
 
-        integer, intent(in) :: ibeg, iend
-        real, dimension(:), intent(in) :: tau_cs, iwco_cs, temp_cs
-        real, dimension(:), intent(in) :: pres_cs, dz_cs, rad_cs
-        real, dimension(:), intent(in) :: rhodz_cs
-        real, intent(out) :: som_tau, som_iwc, som_dz, som_rad
-        real , intent(out) :: pcld, tcld
-
-        integer :: i, ibase, imid
+        INTEGER, intent(in) :: ibeg, iend
+        REAL, DIMENSION(:), intent(in) :: tau_cs, iwco_cs, temp_cs
+        REAL, DIMENSION(:), intent(in) :: pres_cs, dz_cs, rad_cs
+        REAL, DIMENSION(:), intent(in) :: rhodz_cs
+        REAL, intent(out) :: som_tau, som_iwc, som_dz, som_rad
+        REAL , intent(out) :: pcld, tcld
+
+        INTEGER :: i, ibase, imid
+
+        CHARACTER (len = 50)      :: modname = 'simu_airs.caract'
+        CHARACTER (len = 160)     :: abort_message
 
 ! Somme des epaisseurs optiques et des contenus en glace sur le nuage
@@ -585,12 +594,13 @@
 
         if (som_dz .ne. 0.) then
-        som_rad = som_rad/som_dz
+          som_rad = som_rad/som_dz
         else
-        write(*,*) 'som_dez = 0 STOP'
-        write(*,*) 'ibeg, iend =', ibeg, iend
-        do i = ibeg, iend
-        write(*,*) dz_cs(i), rhodz_cs(i)
-        enddo
-        STOP
+          write(*,*) 'som_dez = 0 STOP'
+          write(*,*) 'ibeg, iend =', ibeg, iend
+          do i = ibeg, iend
+             write(*,*) dz_cs(i), rhodz_cs(i)
+          enddo
+          abort_message='see above'
+          CALL abort_physic(modname,abort_message,1)
         endif
 
@@ -611,9 +621,9 @@
         subroutine topbot(ideb,w,ibeg,iend)
 
-        integer, intent(in) :: ideb
-        real, dimension(:), intent(in) :: w
-        integer, intent(out) :: ibeg, iend
-
-        integer :: i, itest
+        INTEGER, intent(in) :: ideb
+        REAL, DIMENSION(:), intent(in) :: w
+        INTEGER, intent(out) :: ibeg, iend
+
+        INTEGER :: i, itest
 
         itest = 0
@@ -642,12 +652,12 @@
         subroutine ordonne(len_cs, rneb_cs, rneb_ord)
 
-        integer, intent(in) :: len_cs
-        real, dimension(:), intent(in) :: rneb_cs
-        real, dimension(:), intent(out) :: rneb_ord
-
-        integer :: i, j, ind_min
-
-        real, dimension(len_cs) :: rneb
-        real :: rneb_max
+        INTEGER, intent(in) :: len_cs
+        REAL, DIMENSION(:), intent(in) :: rneb_cs
+        REAL, DIMENSION(:), intent(out) :: rneb_ord
+
+        INTEGER :: i, j, ind_min
+
+        REAL, DIMENSION(len_cs) :: rneb
+        REAL :: rneb_max
 
 
@@ -689,55 +699,58 @@
        USE dimphy
 
-       real, dimension(klev), intent(in) :: rneb_1D, temp_1D, emis_1D, &
+       REAL, DIMENSION(klev), intent(in) :: rneb_1D, temp_1D, emis_1D, &
      & iwcon_1D, rad_1D
-        real, dimension(klev), intent(in) :: pres, dz, rhodz_1D
-        real, intent(out) :: cc_tot_mesh, cc_hc_mesh, cc_hist_mesh
-        real, intent(out) :: cc_Cb_mesh, cc_ThCi_mesh, cc_Anv_mesh
-        real, intent(out) :: em_hc_mesh, pcld_hc_mesh, tcld_hc_mesh, &
+        REAL, DIMENSION(klev), intent(in) :: pres, dz, rhodz_1D
+        REAL, intent(out) :: cc_tot_mesh, cc_hc_mesh, cc_hist_mesh
+        REAL, intent(out) :: cc_Cb_mesh, cc_ThCi_mesh, cc_Anv_mesh
+        REAL, intent(out) :: em_hc_mesh, pcld_hc_mesh, tcld_hc_mesh, &
      & iwp_hc_mesh
 
-        real, intent(out) :: pcld_Cb_mesh, tcld_Cb_mesh, em_Cb_mesh
-        real, intent(out) :: pcld_ThCi_mesh, tcld_ThCi_mesh, &
+        REAL, intent(out) :: pcld_Cb_mesh, tcld_Cb_mesh, em_Cb_mesh
+        REAL, intent(out) :: pcld_ThCi_mesh, tcld_ThCi_mesh, &
      & em_ThCi_mesh
-        real, intent(out) :: pcld_Anv_mesh, tcld_Anv_mesh, em_Anv_mesh
-
-        real, intent(out) :: em_hist_mesh, iwp_hist_mesh, rad_hist_mesh
-        real, intent(out) :: deltaz_hc_mesh, deltaz_hist_mesh
-
-        real, dimension(:), allocatable :: rneb_cs, temp_cs, emis_cs, &
+        REAL, intent(out) :: pcld_Anv_mesh, tcld_Anv_mesh, em_Anv_mesh
+
+        REAL, intent(out) :: em_hist_mesh, iwp_hist_mesh, rad_hist_mesh
+        REAL, intent(out) :: deltaz_hc_mesh, deltaz_hist_mesh
+
+        REAL, DIMENSION(:), allocatable :: rneb_cs, temp_cs, emis_cs, &
      & iwco_cs
-        real, dimension(:), allocatable :: pres_cs, dz_cs, rad_cs, &
+        REAL, DIMENSION(:), allocatable :: pres_cs, dz_cs, rad_cs, &
      & rhodz_cs
 
-        integer :: i,j,l
-        integer :: ltop, itop, ibot, num_cs, N_cs, len_cs, ics
-
-        real :: som_emi_hc,som_pcl_hc,som_tcl_hc,som_iwp_hc,som_hc,&
+        INTEGER :: i,j,l
+        INTEGER :: ltop, itop, ibot, num_cs, N_cs, len_cs, ics
+
+        REAL :: som_emi_hc,som_pcl_hc,som_tcl_hc,som_iwp_hc,som_hc,&
      & som_hist
-        real :: som_emi_hist, som_iwp_hist, som_deltaz_hc, &
+        REAL :: som_emi_hist, som_iwp_hist, som_deltaz_hc, &
      & som_deltaz_hist
-        real :: som_rad_hist
-        real :: som_Cb, som_ThCi, som_Anv
-        real :: som_emi_Cb, som_tcld_Cb, som_pcld_Cb
-        real :: som_emi_Anv, som_tcld_Anv, som_pcld_Anv
-        real :: som_emi_ThCi, som_tcld_ThCi, som_pcld_ThCi
-        real :: tsom_tot, tsom_hc, tsom_hist
-        real :: prod, prod_hh
-
-        real :: cc_tot_cs, cc_hc_cs, cc_hist_cs
-        real :: cc_Cb_cs, cc_ThCi_cs, cc_Anv_cs
-        real :: pcld_hc_cs, tcld_hc_cs
-        real :: em_hc_cs, iwp_hc_cs, deltaz_hc_cs
-        real :: pcld_Cb_cs, tcld_Cb_cs, em_Cb_cs
-        real :: pcld_ThCi_cs, tcld_ThCi_cs, em_ThCi_cs
-        real :: pcld_Anv_cs, tcld_Anv_cs, em_Anv_cs
-        real :: em_hist_cs, iwp_hist_cs, deltaz_hist_cs, rad_hist_cs
-
-        real, dimension(klev) :: test_tot, test_hc, test_hist
-        real, dimension(klev) :: test_pcld, test_tcld, test_em, test_iwp
-
+        REAL :: som_rad_hist
+        REAL :: som_Cb, som_ThCi, som_Anv
+        REAL :: som_emi_Cb, som_tcld_Cb, som_pcld_Cb
+        REAL :: som_emi_Anv, som_tcld_Anv, som_pcld_Anv
+        REAL :: som_emi_ThCi, som_tcld_ThCi, som_pcld_ThCi
+        REAL :: tsom_tot, tsom_hc, tsom_hist
+        REAL :: prod, prod_hh
+
+        REAL :: cc_tot_cs, cc_hc_cs, cc_hist_cs
+        REAL :: cc_Cb_cs, cc_ThCi_cs, cc_Anv_cs
+        REAL :: pcld_hc_cs, tcld_hc_cs
+        REAL :: em_hc_cs, iwp_hc_cs, deltaz_hc_cs
+        REAL :: pcld_Cb_cs, tcld_Cb_cs, em_Cb_cs
+        REAL :: pcld_ThCi_cs, tcld_ThCi_cs, em_ThCi_cs
+        REAL :: pcld_Anv_cs, tcld_Anv_cs, em_Anv_cs
+        REAL :: em_hist_cs, iwp_hist_cs, deltaz_hist_cs, rad_hist_cs
+
+        REAL, DIMENSION(klev) :: test_tot, test_hc, test_hist
+        REAL, DIMENSION(klev) :: test_pcld, test_tcld, test_em, test_iwp
+
+        CHARACTER (len = 50)      :: modname = 'simu_airs.sim_mesh'
+        CHARACTER (len = 160)     :: abort_message
+        
 
         do j = 1, klev
-        write(*,*) 'simu_airs, j, rneb_1D =', rneb_1D(j)
+          WRITE(lunout,*) 'simu_airs, j, rneb_1D =', rneb_1D(j)
         enddo
 
@@ -991,41 +1004,35 @@
        if (cc_tot_mesh .gt. tsom_tot .and. &
      & abs(cc_tot_mesh-tsom_tot) .gt. 1.e-4) then
-        write(*,*) 'cc_tot_mesh > tsom_tot'
-        write(*,*) cc_tot_mesh, tsom_tot
-        STOP
+           WRITE(abort_message,*)'cc_tot_mesh > tsom_tot', cc_tot_mesh, tsom_tot
+           CALL abort_physic(modname,abort_message,1)
         endif
 
         if (cc_tot_mesh .lt. maxval(test_tot(1:N_CS)) .and. &
      & abs(cc_tot_mesh-maxval(test_tot(1:N_CS))) .gt. 1.e-4) then
-        write(*,*) 'cc_tot_mesh < max'
-        write(*,*) cc_tot_mesh, maxval(test_tot(1:N_CS))
-        STOP
+           WRITE(abort_message,*) 'cc_tot_mesh < max', cc_tot_mesh, maxval(test_tot(1:N_CS))
+           CALL abort_physic(modname,abort_message,1)
         endif
 
         if (cc_hc_mesh .gt. tsom_hc .and. &
      & abs(cc_hc_mesh-tsom_hc) .gt. 1.e-4) then
-        write(*,*) 'cc_hc_mesh > tsom_hc'
-        write(*,*) cc_hc_mesh, tsom_hc
-        STOP
+           WRITE(abort_message,*) 'cc_hc_mesh > tsom_hc', cc_hc_mesh, tsom_hc
+           CALL abort_physic(modname,abort_message,1)
         endif
 
         if (cc_hc_mesh .lt. maxval(test_hc(1:N_CS)) .and. &
      & abs(cc_hc_mesh-maxval(test_hc(1:N_CS))) .gt. 1.e-4) then
-        write(*,*) 'cc_hc_mesh < max'
-        write(*,*) cc_hc_mesh, maxval(test_hc(1:N_CS))
-        STOP
+           WRITE(abort_message,*) 'cc_hc_mesh < max', cc_hc_mesh, maxval(test_hc(1:N_CS))
+           CALL abort_physic(modname,abort_message,1)
         endif
 
         if (cc_hist_mesh .gt. tsom_hist .and. &
      & abs(cc_hist_mesh-tsom_hist) .gt. 1.e-4) then
-        write(*,*) 'cc_hist_mesh > tsom_hist'
-        write(*,*) cc_hist_mesh, tsom_hist
-        STOP
+           WRITE(abort_message,*) 'cc_hist_mesh > tsom_hist', cc_hist_mesh, tsom_hist
+           CALL abort_physic(modname,abort_message,1)
         endif
 
         if (cc_hist_mesh .lt. 0.) then
-        write(*,*) 'cc_hist_mesh < 0'
-        write(*,*) cc_hist_mesh
-        STOP
+           WRITE(abort_message,*) 'cc_hist_mesh < 0', cc_hist_mesh
+           CALL abort_physic(modname,abort_message,1)
         endif
 
@@ -1035,8 +1042,7 @@
      & maxval(test_pcld(1:N_CS)) .ne. 999. &
      & .and. minval(test_pcld(1:N_CS)) .ne. 999.) then
-        write(*,*) 'pcld_hc_mesh est faux'
-        write(*,*) pcld_hc_mesh, maxval(test_pcld(1:N_CS)), &
+           WRITE(abort_message,*) 'pcld_hc_mesh est faux', pcld_hc_mesh, maxval(test_pcld(1:N_CS)), &
      & minval(test_pcld(1:N_CS))
-        STOP
+           CALL abort_physic(modname,abort_message,1)
         endif
 
@@ -1046,7 +1052,7 @@
      & maxval(test_tcld(1:N_CS)) .ne. 999. &
      & .and. minval(test_tcld(1:N_CS)) .ne. 999.) then
-        write(*,*) 'tcld_hc_mesh est faux'
-        write(*,*) tcld_hc_mesh, maxval(test_tcld(1:N_CS)), &
-     & minval(test_tcld(1:N_CS))
+           WRITE(abort_message,*) 'tcld_hc_mesh est faux', tcld_hc_mesh, maxval(test_tcld(1:N_CS)), &
+                & minval(test_tcld(1:N_CS))
+           CALL abort_physic(modname,abort_message,1)
         endif
 
@@ -1056,8 +1062,7 @@
      & minval(test_em(1:N_CS)) .ne. 999. .and. &
      & maxval(test_em(1:N_CS)) .ne. 999. ) then
-        write(*,*) 'em_hc_mesh est faux'
-        write(*,*) em_hc_mesh, maxval(test_em(1:N_CS)), &
+           WRITE(abort_message,*) 'em_hc_mesh est faux', em_hc_mesh, maxval(test_em(1:N_CS)), &
      & minval(test_em(1:N_CS))
-        STOP
+           CALL abort_physic(modname,abort_message,1)
         endif
 
@@ -1101,11 +1106,12 @@
         subroutine test_bornes(sx,x,bsup,binf)
 
-        real, intent(in) :: x, bsup, binf
+        REAL, intent(in) :: x, bsup, binf
         character*14, intent(in) :: sx
+        CHARACTER (len = 50)      :: modname = 'simu_airs.test_bornes'
+        CHARACTER (len = 160)     :: abort_message
 
         if (x .gt. bsup .or. x .lt. binf) then
-        write(*,*) sx, 'est faux'
-        write(*,*) sx, x
-        STOP
+          WRITE(abort_message,*) sx, 'est faux', sx, x
+          CALL abort_physic(modname,abort_message,1)
         endif
  
@@ -1134,44 +1140,44 @@
         include "YOMCST.h"
 
-        integer,intent(in) :: itap
-
-        real, dimension(klon,klev), intent(in) :: &
+        INTEGER,intent(in) :: itap
+
+        REAL, DIMENSION(klon,klev), intent(in) :: &
      & rneb_airs, temp_airs, cldemi_airs, iwcon0_airs, &
      & rad_airs, geop_airs, pplay_airs, paprs_airs
 
-       real, dimension(klon,klev) :: &
+       REAL, DIMENSION(klon,klev) :: &
      & rhodz_airs, rho_airs, iwcon_airs
 
-        real, dimension(klon),intent(out) :: alt_tropo
-
-        real, dimension(klev) :: rneb_1D, temp_1D, &
+        REAL, DIMENSION(klon),intent(out) :: alt_tropo
+
+        REAL, DIMENSION(klev) :: rneb_1D, temp_1D, &
      & emis_1D, rad_1D, pres_1D, alt_1D, &
      & rhodz_1D, dz_1D, iwcon_1D
 
-        integer :: i, j
-
-        real :: cc_tot_mesh, cc_hc_mesh, cc_hist_mesh
-        real :: cc_Cb_mesh, cc_ThCi_mesh, cc_Anv_mesh
-        real :: pcld_hc_mesh, tcld_hc_mesh, em_hc_mesh, iwp_hc_mesh
-        real :: em_hist_mesh, iwp_hist_mesh
-        real :: deltaz_hc_mesh, deltaz_hist_mesh, rad_hist_mesh
-        real :: pcld_Cb_mesh, tcld_Cb_mesh, em_Cb_mesh
-        real :: pcld_ThCi_mesh, tcld_ThCi_mesh, em_ThCi_mesh
-        real :: pcld_Anv_mesh, tcld_Anv_mesh, em_Anv_mesh
-
-        real, dimension(klon),intent(out) :: map_prop_hc, map_prop_hist
-        real, dimension(klon),intent(out) :: map_emis_hc, map_iwp_hc
-        real, dimension(klon),intent(out) :: map_deltaz_hc, map_pcld_hc
-        real, dimension(klon),intent(out) :: map_tcld_hc
-        real, dimension(klon),intent(out) :: map_emis_Cb,map_pcld_Cb,map_tcld_Cb 
-        real, dimension(klon),intent(out) :: &
+        INTEGER :: i, j
+
+        REAL :: cc_tot_mesh, cc_hc_mesh, cc_hist_mesh
+        REAL :: cc_Cb_mesh, cc_ThCi_mesh, cc_Anv_mesh
+        REAL :: pcld_hc_mesh, tcld_hc_mesh, em_hc_mesh, iwp_hc_mesh
+        REAL :: em_hist_mesh, iwp_hist_mesh
+        REAL :: deltaz_hc_mesh, deltaz_hist_mesh, rad_hist_mesh
+        REAL :: pcld_Cb_mesh, tcld_Cb_mesh, em_Cb_mesh
+        REAL :: pcld_ThCi_mesh, tcld_ThCi_mesh, em_ThCi_mesh
+        REAL :: pcld_Anv_mesh, tcld_Anv_mesh, em_Anv_mesh
+
+        REAL, DIMENSION(klon),intent(out) :: map_prop_hc, map_prop_hist
+        REAL, DIMENSION(klon),intent(out) :: map_emis_hc, map_iwp_hc
+        REAL, DIMENSION(klon),intent(out) :: map_deltaz_hc, map_pcld_hc
+        REAL, DIMENSION(klon),intent(out) :: map_tcld_hc
+        REAL, DIMENSION(klon),intent(out) :: map_emis_Cb,map_pcld_Cb,map_tcld_Cb 
+        REAL, DIMENSION(klon),intent(out) :: &
      & map_emis_ThCi,map_pcld_ThCi,map_tcld_ThCi
-        real, dimension(klon),intent(out) :: &
+        REAL, DIMENSION(klon),intent(out) :: &
      & map_emis_Anv,map_pcld_Anv,map_tcld_Anv
-        real, dimension(klon),intent(out) :: &
+        REAL, DIMENSION(klon),intent(out) :: &
      & map_emis_hist,map_iwp_hist,map_deltaz_hist,&
      & map_rad_hist
-       real, dimension(klon),intent(out) :: map_ntot,map_hc,map_hist
-       real, dimension(klon),intent(out) :: map_Cb,map_ThCi,map_Anv
+        REAL, DIMENSION(klon),intent(out) :: map_ntot,map_hc,map_hist
+        REAL, DIMENSION(klon),intent(out) :: map_Cb,map_ThCi,map_Anv
  
  
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/sisvat/surf_sisvat_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/sisvat/surf_sisvat_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/sisvat/surf_sisvat_mod.F90	(revision 3605)
@@ -1540,4 +1540,5 @@
     INTEGER isl, ikl, i, isn
     CHARACTER (len=2) :: str2
+    INTEGER           :: pass
 
       isno(:)       = 0       
@@ -1617,23 +1618,24 @@
 
       CALL open_restartphy(fichnom)
-      CALL put_field("longitude", &
+      DO pass = 1, 2
+        CALL put_field(pass,"longitude", &
                     "Longitudes de la grille physique",rlon)     
-      CALL put_field("latitude","Latitudes de la grille physique",rlat)
-
-      CALL put_field("n_snows", "number of snow/ice layers",isno)
-      CALL put_field("n_ice_top", "number of top ice layers",ispi)
-      CALL put_field("n_ice", "number of ice layers",iice)
-      CALL put_field("IR_soil", "Soil IR flux",IRs)
-      CALL put_field("LMO", "Monin-Obukhov Scale",LMO)
-      CALL put_field("surf_water", "Surficial water",rusn)
-      CALL put_field("snow_buffer", "Snow buffer layer",Bufs)
-      CALL put_field("alb_1", "albedo sw",alb1)
-      CALL put_field("alb_2", "albedo nIR",alb2)
-      CALL put_field("alb_3", "albedo fIR",alb3)
-      CALL put_field("to_ice", "Snow passed to ice",toic)
+        CALL put_field(pass,"latitude","Latitudes de la grille physique",rlat)
+  
+        CALL put_field(pass,"n_snows", "number of snow/ice layers",isno)
+        CALL put_field(pass,"n_ice_top", "number of top ice layers",ispi)
+        CALL put_field(pass,"n_ice", "number of ice layers",iice)
+        CALL put_field(pass,"IR_soil", "Soil IR flux",IRs)
+        CALL put_field(pass,"LMO", "Monin-Obukhov Scale",LMO)
+        CALL put_field(pass,"surf_water", "Surficial water",rusn)
+        CALL put_field(pass,"snow_buffer", "Snow buffer layer",Bufs)
+        CALL put_field(pass,"alb_1", "albedo sw",alb1)
+        CALL put_field(pass,"alb_2", "albedo nIR",alb2)
+        CALL put_field(pass,"alb_3", "albedo fIR",alb3)
+        CALL put_field(pass,"to_ice", "Snow passed to ice",toic)
 
  !     DO i = 1, 5
  !       WRITE(str2,'(i2.2)') i
- !       CALL put_field("turb_veloc"//str2, &
+ !       CALL put_field(pass,"turb_veloc"//str2, &
  !                      "various turbulent velocities"//str2, &
  !                      turb_vel(:,i))
@@ -1641,96 +1643,97 @@
  !     DO i = 1, 9
  !       WRITE(str2,'(i2.2)') i
- !       CALL put_field("rough_length"//str2, &
+ !       CALL put_field(pass,"rough_length"//str2, &
  !                      "various roughness lengths"//str2, &
  !                      rlength(:,i))
  !     ENDDO
-      DO isn = 1,nsno
-        IF (isn.LE.99) THEN
-          WRITE(str2,'(i2.2)') isn
-          CALL put_field("AGESNOW"//str2, &
+        DO isn = 1,nsno
+          IF (isn.LE.99) THEN
+            WRITE(str2,'(i2.2)') isn
+            CALL put_field(pass,"AGESNOW"//str2, &
                          "Age de la neige layer No."//str2, &
                          agsn(:,isn))
-        ELSE
-          PRINT*, "Trop de couches"
-          CALL abort
-        ENDIF
-      ENDDO
-      DO isn = 1,nsno
-        IF (isn.LE.99) THEN
-          WRITE(str2,'(i2.2)') isn
-          CALL put_field("DZSNOW"//str2, &
+          ELSE
+            PRINT*, "Trop de couches"
+            CALL abort
+          ENDIF
+        ENDDO
+        DO isn = 1,nsno
+          IF (isn.LE.99) THEN
+            WRITE(str2,'(i2.2)') isn
+            CALL put_field(pass,"DZSNOW"//str2, &
                          "Snow/ice thickness layer No."//str2, &
                          dzsn(:,isn))
-        ELSE
-          PRINT*, "Trop de couches"
-          CALL abort
-        ENDIF
-      ENDDO
-      DO isn = 1,nsno
-        IF (isn.LE.99) THEN
-          WRITE(str2,'(i2.2)') isn
-          CALL put_field("G2SNOW"//str2, &
+          ELSE
+            PRINT*, "Trop de couches"
+            CALL abort
+          ENDIF
+        ENDDO
+        DO isn = 1,nsno
+          IF (isn.LE.99) THEN
+            WRITE(str2,'(i2.2)') isn
+            CALL put_field(pass,"G2SNOW"//str2, &
                          "Snow Property 2, layer No."//str2, &
                          G2sn(:,isn))
-        ELSE
-          PRINT*, "Trop de couches"
-          CALL abort
-        ENDIF
-      ENDDO
-      DO isn = 1,nsno
-        IF (isn.LE.99) THEN
-          WRITE(str2,'(i2.2)') isn
-          CALL put_field("G1SNOW"//str2, &
+          ELSE
+            PRINT*, "Trop de couches"
+            CALL abort
+          ENDIF
+        ENDDO
+        DO isn = 1,nsno
+          IF (isn.LE.99) THEN
+            WRITE(str2,'(i2.2)') isn
+            CALL put_field(pass,"G1SNOW"//str2, &
                          "Snow Property 1, layer No."//str2, &
                          G1sn(:,isn))
-        ELSE
-          PRINT*, "Trop de couches"
-          CALL abort
-        ENDIF
-      ENDDO
-      DO isn = 1,nsismx
-        IF (isn.LE.99) THEN
-          WRITE(str2,'(i2.2)') isn
-          CALL put_field("ETA"//str2, &
+          ELSE
+            PRINT*, "Trop de couches"
+            CALL abort
+          ENDIF
+        ENDDO
+        DO isn = 1,nsismx
+          IF (isn.LE.99) THEN
+            WRITE(str2,'(i2.2)') isn
+            CALL put_field(pass,"ETA"//str2, &
                          "Soil/snow water content layer No."//str2, &
                          eta(:,isn))
-        ELSE
-          PRINT*, "Trop de couches"
-          CALL abort
-        ENDIF
+          ELSE
+            PRINT*, "Trop de couches"
+            CALL abort
+          ENDIF
+        ENDDO
+        DO isn = 1,nsismx   !nsno
+          IF (isn.LE.99) THEN
+            WRITE(str2,'(i2.2)') isn
+            CALL put_field(pass,"RO"//str2, &
+                           "Snow density layer No."//str2, &
+                           ro(:,isn))
+          ELSE
+            PRINT*, "Trop de couches"
+            CALL abort
+          ENDIF
+        ENDDO
+        DO isn = 1,nsismx
+          IF (isn.LE.99) THEN
+            WRITE(str2,'(i2.2)') isn
+            CALL put_field(pass,"TSS"//str2, &
+                           "Soil/snow temperature layer No."//str2, &
+                           Tsis(:,isn))
+          ELSE
+            PRINT*, "Trop de couches"
+            CALL abort
+          ENDIF
+        ENDDO
+        DO isn = 1,nsno
+          IF (isn.LE.99) THEN
+            WRITE(str2,'(i2.2)') isn
+            CALL put_field(pass,"HISTORY"//str2, &
+                           "Snow history layer No."//str2, &
+                           isto(:,isn))
+          ELSE
+            PRINT*, "Trop de couches"
+            CALL abort
+          ENDIF
+        ENDDO
       ENDDO
-      DO isn = 1,nsismx   !nsno
-        IF (isn.LE.99) THEN
-          WRITE(str2,'(i2.2)') isn
-          CALL put_field("RO"//str2, &
-                         "Snow density layer No."//str2, &
-                         ro(:,isn))
-        ELSE
-          PRINT*, "Trop de couches"
-          CALL abort
-        ENDIF
-      ENDDO
-      DO isn = 1,nsismx
-        IF (isn.LE.99) THEN
-          WRITE(str2,'(i2.2)') isn
-          CALL put_field("TSS"//str2, &
-                         "Soil/snow temperature layer No."//str2, &
-                         Tsis(:,isn))
-        ELSE
-          PRINT*, "Trop de couches"
-          CALL abort
-        ENDIF
-      ENDDO
-      DO isn = 1,nsno
-        IF (isn.LE.99) THEN
-          WRITE(str2,'(i2.2)') isn
-          CALL put_field("HISTORY"//str2, &
-                         "Snow history layer No."//str2, &
-                         isto(:,isn))
-        ELSE
-          PRINT*, "Trop de couches"
-          CALL abort
-        ENDIF
-      ENDDO
 
   END SUBROUTINE sisvatredem
Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/slab_heat_transp_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/slab_heat_transp_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/slab_heat_transp_mod.F90	(revision 3605)
@@ -83,6 +83,5 @@
                                   cu_,cuvsurcv_,cv_,cvusurcu_, &
                                   aire_,apoln_,apols_, &
-                                  aireu_,airev_,rlatv)
-    USE comconst_mod, ONLY: omeg, rad
+                                  aireu_,airev_,rlatv, rad, omeg)
     ! number of points in lon, lat
     IMPLICIT NONE
@@ -104,10 +103,15 @@
     REAL,INTENT(IN) :: airev_(ip1jm)
     REAL,INTENT(IN) :: rlatv(nbp_lat-1)
-
+    REAL,INTENT(IN) :: rad
+    REAL,INTENT(IN) :: omeg
+
+    CHARACTER (len = 20) :: modname = 'slab_heat_transp'
+    CHARACTER (len = 80) :: abort_message
+    
     ! Sanity check on dimensions
     if ((ip1jm.ne.((nbp_lon+1)*(nbp_lat-1))).or. &
         (ip1jmp1.ne.((nbp_lon+1)*nbp_lat))) then
-      write(*,*) "ini_slab_transp_geom Error: wrong array sizes"
-      stop
+      abort_message="ini_slab_transp_geom Error: wrong array sizes"
+      CALL abort_physic(modname,abort_message,1)
     endif
 ! Allocations could be done only on master process/thread...
@@ -924,8 +928,11 @@
   INTEGER j,ifield,ig
 
+  CHARACTER (len = 20)                      :: modname = 'slab_heat_transp'
+  CHARACTER (len = 80)                      :: abort_message
+
   ! Sanity check:
   IF(klon_glo.NE.2+(jm-2)*(im-1)) THEN
-    WRITE(*,*) "gr_dyn_fi error, wrong sizes"
-    STOP
+    abort_message="gr_dyn_fi error, wrong sizes"
+    CALL abort_physic(modname,abort_message,1)
   ENDIF
 
